//+------------------------------------------------------------------+
//|                                                      KeyLime.mq4 |
//|                          Copyright  2007, Braunberger Autosport |
//|                                       http://www.braunberger.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Braunberger Autosport"
#property link      "http://www.braunberger.com"

#property indicator_chart_window
#property indicator_buffers 5

extern bool DrawLines=true;
extern bool AlertLines=false;
extern int AlertWindow=5;

double tday_open;
double tweek_open;
double tmo_open;

double tday_high;
double tday_low;
double yday_high;
double yday_low;
double tweek_high;
double tweek_low;
double yweek_high;
double yweek_low;
double tmo_high;
double tmo_low;
double ymo_high;
double ymo_low;
double sixmo_high;
double sixmo_low;

int lastTime=0;
int lastAlert=99;

//+------------------------------------------------------------------+
//| Custom indicator High/Low Getter                                 |
//+------------------------------------------------------------------+
void getHighLow()
  {  
    tday_high=iHigh(NULL,PERIOD_D1,0);
    tday_low=iLow(NULL,PERIOD_D1,0);
    
    yday_high=iHigh(NULL,PERIOD_D1,1);
    yday_low=iLow(NULL,PERIOD_D1,1);
    
    tweek_high=iHigh(NULL,PERIOD_W1,0);
    tweek_low=iLow(NULL,PERIOD_W1,0);
    
    yweek_high=iHigh(NULL,PERIOD_W1,1);
    yweek_low=iLow(NULL,PERIOD_W1,1);
    
    tmo_high=iHigh(NULL,PERIOD_MN1,0);
    tmo_low=iLow(NULL,PERIOD_MN1,0);
    
    ymo_high=iHigh(NULL,PERIOD_MN1,1);
    ymo_low=iLow(NULL,PERIOD_MN1,1);
    
    sixmo_high=iHigh(NULL,PERIOD_MN1,iHighest(NULL,PERIOD_MN1,MODE_HIGH,6,0));
    sixmo_low=iLow(NULL,PERIOD_MN1,iLowest(NULL,PERIOD_MN1,MODE_LOW,6,0));
    
    tday_open=iOpen(NULL,PERIOD_D1,0);
    tweek_open=iOpen(NULL,PERIOD_W1,0);
    tmo_open=iOpen(NULL,PERIOD_MN1,0);
  }
//+------------------------------------------------------------------+
//| Custom indicator High/Low Drawer                                 |
//+------------------------------------------------------------------+
void drawHighLow()
  { 
    ObjectCreate("Todays Open",OBJ_HLINE,0,TimeCurrent(), tday_open);
    ObjectSet("Todays Open",OBJPROP_COLOR,SkyBlue);
    ObjectSet("Todays Open",OBJPROP_BACK,true);
    ObjectSetText("Todays Open","                                             Todays Open",8);
    
    ObjectCreate("Week Open",OBJ_HLINE,0,TimeCurrent(), tweek_open);
    ObjectSet("Week Open",OBJPROP_COLOR,SkyBlue);
    ObjectSet("Week Open",OBJPROP_BACK,true);
    ObjectSetText("Week Open","                                             Week Open",8);
    
    ObjectCreate("Month Open",OBJ_HLINE,0,TimeCurrent(), tmo_open);
    ObjectSet("Month Open",OBJPROP_COLOR,SkyBlue);
    ObjectSet("Month Open",OBJPROP_BACK,true);
    ObjectSetText("Month Open","                                             Month Open",8);
     
    ObjectCreate("Todays High",OBJ_HLINE,0,TimeCurrent(), tday_high);
    ObjectSet("Todays High",OBJPROP_COLOR,SkyBlue);
    ObjectSet("Todays High",OBJPROP_BACK,true);
    ObjectSetText("Todays High","                              Todays High",8);
    
    ObjectCreate("Todays Low",OBJ_HLINE,0,TimeCurrent(), tday_low);
    ObjectSet("Todays Low",OBJPROP_COLOR,Gold);
    ObjectSet("Todays Low",OBJPROP_BACK,true);
    ObjectSetText("Todays Low","                              Todays Low",8);
    
    ObjectCreate("Ydays High",OBJ_HLINE,0,TimeCurrent(), yday_high);
    ObjectSet("Ydays High",OBJPROP_COLOR,DeepSkyBlue);
    ObjectSet("Ydays High",OBJPROP_BACK,true);
    ObjectSetText("Ydays High","                              Ydays High",8);
    
    ObjectCreate("Ydays Low",OBJ_HLINE,0,TimeCurrent(), yday_low);
    ObjectSet("Ydays Low",OBJPROP_COLOR,Orange);
    ObjectSet("Ydays Low",OBJPROP_BACK,true);
    ObjectSetText("Ydays Low","                              Ydays Low",8);
    
    ObjectCreate("Week High",OBJ_HLINE,0,TimeCurrent(), tweek_high);
    ObjectSet("Week High",OBJPROP_COLOR,Gray);
    ObjectSet("Week High",OBJPROP_BACK,true);
    ObjectSetText("Week High","               Week High",8);
    
    ObjectCreate("Week Low",OBJ_HLINE,0,TimeCurrent(), tweek_low);
    ObjectSet("Week Low",OBJPROP_COLOR,Orange);
    ObjectSet("Week Low",OBJPROP_BACK,true);
    ObjectSetText("Week Low","               Week Low",8);
    
    ObjectCreate("Last Week High",OBJ_HLINE,0,TimeCurrent(), yweek_high);
    ObjectSet("Last Week High",OBJPROP_COLOR,Gray);
    ObjectSet("Last Week High",OBJPROP_BACK,true);
    ObjectSetText("Last Week High","               Last Week High",8);
    
    ObjectCreate("Last Week Low",OBJ_HLINE,0,TimeCurrent(), yweek_low);
    ObjectSet("Last Week Low",OBJPROP_COLOR,Orange);
    ObjectSet("Last Week Low",OBJPROP_BACK,true);
    ObjectSetText("Last Week Low","               Last Week Low",8);
    
    ObjectCreate("Month High",OBJ_HLINE,0,TimeCurrent(), tmo_high);
    ObjectSet("Month High",OBJPROP_COLOR,Blue);
    ObjectSet("Month High",OBJPROP_BACK,true);
    ObjectSetText("Month High","Month High",8);
    
    ObjectCreate("Month Low",OBJ_HLINE,0,TimeCurrent(), tmo_low);
    ObjectSet("Month Low",OBJPROP_COLOR,Red);
    ObjectSet("Month Low",OBJPROP_BACK,true);
    ObjectSetText("Month Low","Month Low",8);
    
    ObjectCreate("Last Month High",OBJ_HLINE,0,TimeCurrent(), ymo_high);
    ObjectSet("Last Month High",OBJPROP_COLOR,Blue);
    ObjectSet("Last Month High",OBJPROP_BACK,true);
    ObjectSetText("Last Month High","Last Month High",8);
    
    ObjectCreate("Last Month Low",OBJ_HLINE,0,TimeCurrent(), ymo_low);
    ObjectSet("Last Month Low",OBJPROP_COLOR,Red);
    ObjectSet("Last Month Low",OBJPROP_BACK,true);
    ObjectSetText("Last Month Low","Last Month Low",8);
    
    ObjectCreate("Six Month High",OBJ_HLINE,0,TimeCurrent(), sixmo_high);
    ObjectSet("Six Month High",OBJPROP_COLOR,Blue);
    ObjectSet("Six Month High",OBJPROP_BACK,true);
    ObjectSetText("Six Month High","Six Month High",8);
    
    ObjectCreate("Six Month Low",OBJ_HLINE,0,TimeCurrent(), sixmo_low);
    ObjectSet("Six Month Low",OBJPROP_COLOR,Red);
    ObjectSet("Six Month Low",OBJPROP_BACK,true);
    ObjectSetText("Six Month Low","Six Month Low",8);
  }
//+------------------------------------------------------------------+
//| Custom indicator Alert Thingy                                    |
//+------------------------------------------------------------------+
void doAlerts()
  { 
    if(Hour()>10 && Bid<tday_open+AlertWindow*Point && Bid>tday_open-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Today\'s Open");
    if(DayOfWeek()>1 && Bid<tweek_open+AlertWindow*Point && Bid>tweek_open-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: This Week\'s Open");
    if(Day()>6 && Bid<tmo_open+AlertWindow*Point && Bid>tmo_open-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Month\'s Open");
    if(Hour()>6 && Bid<tday_high+AlertWindow*Point && Bid>tday_high-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Today\'s High");
    if(Hour()>6 && Bid<tday_low+AlertWindow*Point && Bid>tday_low-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Today\'s Low");
    if(Bid<yday_high+AlertWindow*Point && Bid>yday_high-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Yesterday\'s High");
    if(Bid<yday_low+AlertWindow*Point && Bid>yday_low-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Yesterday\'s Low");
    if(Bid<tweek_high+AlertWindow*Point && Bid>tweek_high-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: This Week\'s High");
    if(Bid<tweek_low+AlertWindow*Point && Bid>tweek_low-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: This Week\'s Low");
    if(Bid<yweek_high+AlertWindow*Point && Bid>yweek_high-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Last Week\'s High");
    if(Bid<yweek_low+AlertWindow*Point && Bid>yweek_low-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Last Week\'s Low");
    if(Bid<tmo_high+AlertWindow*Point && Bid>tmo_high-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Month\'s High");
    if(Bid<tmo_low+AlertWindow*Point && Bid>tmo_low-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Month\'s Low");
    if(Bid<ymo_high+AlertWindow*Point && Bid>ymo_high-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Last Month\'s High");
    if(Bid<ymo_low+AlertWindow*Point && Bid>ymo_low-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Last Month\'s Low");
    if(Bid<sixmo_high+AlertWindow*Point && Bid>sixmo_high-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Six Month High");
    if(Bid<sixmo_low+AlertWindow*Point && Bid>sixmo_low-AlertWindow*Point)
      Alert(Symbol(),"KeyLime: Six Month Low");
      
    lastAlert=TimeCurrent()/60;
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom line delete function                                      |
//+------------------------------------------------------------------+  
  void DelHighLow() {
   ObjectDelete("Todays High");
   ObjectDelete("Todays Low");
   ObjectDelete("Ydays High");
   ObjectDelete("Ydays Low");
   ObjectDelete("Week High");
   ObjectDelete("Week Low");
   ObjectDelete("Last Week High");
   ObjectDelete("Last Week Low");
   ObjectDelete("Month High");
   ObjectDelete("Month Low");
   ObjectDelete("Last Month High");
   ObjectDelete("Last Month Low");
   ObjectDelete("Todays Open");
   ObjectDelete("Week Open");
   ObjectDelete("Month Open");
   ObjectDelete("Six Month High");
   ObjectDelete("Six Month Low");
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
         DelHighLow();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if(TimeCurrent()/60-lastTime>15){
     DelHighLow();
     getHighLow();
     if(DrawLines) drawHighLow();
     if(AlertLines && TimeCurrent()/60-lastAlert>10) doAlerts();
     lastTime=TimeCurrent()/60;
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+